DECLARE SUB MorePrompt (Input.String$, Input.Mask$, Output.String$)
DECLARE SUB DisplayError (Temp$)
REM file: Deldir.bas - Public Domain DOS Utility
REM Version 1.0a created 05/22/1995
REM Version 1.1a created 03/26/2001

' default integer variables
DEFINT A-Z
REM $DYNAMIC

' define boolean values
CONST True = -1
CONST False = NOT True
CONST NUL = ""

' define color values
CONST Black = 0
CONST Plain = 7
CONST Green = 10
CONST Red = 12
CONST Yellow = 14
CONST White = 15

' get include files
REM $INCLUDE: 'qbx.bi'
REM $INCLUDE: 'dta.bi'

' declare functions
DECLARE FUNCTION ParseLine (S$)
DECLARE FUNCTION BreakIS ()
DECLARE FUNCTION ClearBreak ()
DECLARE FUNCTION KeyIS ()

' initialize filename buffer
DIM ASCIZ AS STRING * 260, DTAfile AS DTAtype

' initialize drive variables
COMMON SHARED Drive.Number AS INTEGER, Current.Drive AS INTEGER

' declare program dta
DIM BASIC.DTA.SEG AS INTEGER, BASIC.DTA.OFF AS INTEGER

' declare registers
COMMON SHARED InregsX AS RegTypeX, OutregsX AS RegTypeX

' declare work variables
COMMON SHARED Continuous.Display AS INTEGER, Display.Errors AS INTEGER
COMMON SHARED Windows.Detected AS INTEGER, Prompt.Delete AS INTEGER
COMMON SHARED Quit.Searching AS INTEGER

' declare command line work variables
COMMON SHARED Command.Line AS STRING, Command.Line.Redirect AS STRING
COMMON SHARED Command.Work AS STRING, Control.Break AS INTEGER

' backwards compatible for bc 7.1
REM $INCLUDE: 'bc7.inc'

' increase stack size
STACK STACK

' declare standard error trap
ON ERROR GOTO Error.Routine
SCREEN 12
' store basic dta
InregsX.AX = &H2F00
CALL InterruptX(&H21, InregsX, OutregsX)
BASIC.DTA.SEG = OutregsX.ES
BASIC.DTA.OFF = OutregsX.BX

' get current drive
InregsX.AX = &H1900
CALL InterruptX(&H21, InregsX, OutregsX)
Current.Drive = OutregsX.AX AND &HFF

' check windows dos
InregsX.AX = &H160A
CALL InterruptX(&H2F, InregsX, OutregsX)
IF OutregsX.AX = False THEN
   Temp = (OutregsX.BX AND &HFF00) / 256
   IF Temp >= 4 THEN
      Windows.Detected = True
   END IF
END IF

' check command line
SELECT CASE COMMAND$
CASE "/?"
   GOTO Boot.Usage
END SELECT

' read command line from PSP
Command.Line = NUL
InregsX.AX = &H6200
CALL InterruptX(&H21, InregsX, OutregsX)
PSPsegment = OutregsX.BX
PSPoffset = 128
DEF SEG = PSPsegment
FOR Count = 1 TO 127
   Command.Char = PEEK(PSPoffset + Count)
   SELECT CASE Command.Char
   CASE 0, 10, 13
      EXIT FOR
   CASE ELSE
      Command.Line = Command.Line + CHR$(Command.Char)
   END SELECT
NEXT
DEF SEG
IF Command.Line = NUL THEN
   Command.Line = UCASE$(ENVIRON$("DELDIR"))
END IF

' get switches from command line
Continuous.Display = ParseLine("/C")
Prompt.Delete = ParseLine("/P")
Display.Errors = ParseLine("/Z")
Control.Break = ParseLine("/~")

' recheck command line
IF INSTR(Command.Line$, "/") THEN
   GOTO Boot.Usage
END IF

' store command line
Command.Line = RTRIM$(Command.Line)
Command.Line = LTRIM$(Command.Line)
Command.Line.Redirect = Command.Line

' check break flag override
IF Control.Break THEN
   Var = ClearBreak
END IF

' search through all input filenames
Redirected.Input = False
DO
   ' check control break
   IF BreakIS THEN
      EXIT DO
   END IF

   ' get standard input
   Standard.Input$ = NUL
   InregsX.AX = &HB00
   CALL InterruptX(&H21, InregsX, OutregsX)
   DO WHILE (OutregsX.AX AND &HFF) = &HFF
      Redirected.Input = True
      InregsX.AX = &H800
      CALL InterruptX(&H21, InregsX, OutregsX)
      Char$ = CHR$(OutregsX.AX AND &HFF)
      SELECT CASE ASC(Char$)
      CASE 10, 26
      CASE 13
	 EXIT DO
      CASE ELSE
	 Standard.Input$ = Standard.Input$ + Char$
      END SELECT
      InregsX.AX = &HB00
      CALL InterruptX(&H21, InregsX, OutregsX)
   LOOP

   ' clear break flag
   IF Redirected.Input = False THEN
      IF Cleared = False THEN
	 Cleared = True
	 Var = ClearBreak
      END IF
   END IF

   ' check control break
   IF BreakIS THEN
      EXIT DO
   END IF

   ' check nul filename input
   IF Redirected.Input = False THEN
      IF Standard.Input$ = NUL THEN
	 X$ = INKEY$ ' quits here
	 IF X$ = CHR$(0) + CHR$(0) THEN
	    EXIT DO
	 END IF
      END IF
   END IF

   ' check standard input
   IF Redirected.Input THEN
      IF Standard.Input$ = NUL THEN
	 EXIT DO
      END IF
   END IF

   ' display header
   GOSUB Header

   ' store entire command
   Command.Work = Command.Line.Redirect

   ' filename processing loop
   DO

      ' store redirected input
      Standard.Input$ = RTRIM$(Standard.Input$)
      Standard.Input$ = LTRIM$(Standard.Input$)
      IF LEFT$(Standard.Input$, 1) = CHR$(34) THEN
	 Standard.Input$ = MID$(Standard.Input$, 2)
      END IF
      IF RIGHT$(Standard.Input$, 1) = CHR$(34) THEN
	 Standard.Input$ = LEFT$(Standard.Input$, LEN(Standard.Input$) - 1)
      END IF

      ' store entire command
      IF LEFT$(Command.Line, 1) = CHR$(34) THEN
	 Imbedded = INSTR(2, Command.Line, CHR$(34))
	 IF Imbedded THEN
	    Command.Work = Standard.Input$ + MID$(Command.Line, 2, Imbedded - 2)
	    Command.Line = MID$(Command.Line, Imbedded + 1)
	 ELSE
	    Command.Work = Standard.Input$ + Command.Line
	    Command.Line = NUL
	 END IF
      ELSE
	 Imbedded = INSTR(Command.Line, " ")
	 IF Imbedded THEN
	    Command.Work = Standard.Input$ + LEFT$(Command.Line, Imbedded - 1)
	    Command.Line = MID$(Command.Line, Imbedded + 1)
	 ELSE
	    Command.Work = Standard.Input$ + Command.Line
	    Command.Line = NUL
	 END IF
      END IF
      Command.Line = LTRIM$(Command.Line)
      Command.Line = RTRIM$(Command.Line)

      ' store current drive
      IF MID$(Command.Work, 2, 1) = ":" THEN
	 Drive.Number = ASC(UCASE$(LEFT$(Command.Work, 1))) - 65
	 Command.Work = MID$(Command.Work, 3)
      ELSE
	 Drive.Number = Current.Drive
      END IF

      ' check windows dos
      IF Windows.Detected THEN
	 ' get current directory
	 InregsX.AX = &H7147
	 InregsX.DX = Drive.Number + 1
	 InregsX.DS = VARSEG(ASCIZ)
	 InregsX.SI = VARPTR(ASCIZ)
	 CALL InterruptX(&H21, InregsX, OutregsX)
      ELSE
	 ' get current directory
	 InregsX.AX = &H4700
	 InregsX.DX = Drive.Number + 1
	 InregsX.DS = VARSEG(ASCIZ)
	 InregsX.SI = VARPTR(ASCIZ)
	 CALL InterruptX(&H21, InregsX, OutregsX)
      END IF

      ' display any errors
      CALL DisplayError("Error accessing drive.")

      ' check carry flag error
      IF (OutregsX.Flags AND &H1) = &H0 THEN

	 ' store current directory
	 Directory.Search$ = "\" + LEFT$(ASCIZ, INSTR(ASCIZ, CHR$(0)) - 1)
	 Imbedded1 = INSTR(Command.Work, "\")
	 Imbedded2 = Imbedded1
	 WHILE Imbedded1
	    Imbedded2 = Imbedded1
	    Imbedded1 = INSTR(Imbedded1 + 1, Command.Work, "\")
	 WEND
	 IF Imbedded2 THEN
	    Directory.Search$ = LEFT$(Command.Work, Imbedded2)
	    Command.Work = MID$(Command.Work, Imbedded2 + 1)
	 END IF
	 IF RIGHT$(Directory.Search$, 1) <> "\" THEN
	    Directory.Search$ = Directory.Search$ + "\"
	 END IF

	 ' get filename spec
	 Filename.Search$ = Command.Work
	 IF Filename.Search$ = NUL THEN
	    IF RIGHT$(Directory.Search$, 1) = "\" THEN
	       IF LEN(Directory.Search$) > 1 THEN
		  Directory.Search$ = LEFT$(Directory.Search$, LEN(Directory.Search$) - 1)
	       END IF
	    END IF
	 ELSE
	    Directory.Search$ = Directory.Search$ + Filename.Search$
	 END IF
	 Command.Work = NUL

	 ' change to drive
	 InregsX.AX = &HE00
	 InregsX.DX = Drive.Number
	 CALL InterruptX(&H21, InregsX, OutregsX)

	 ' make directory filename
	 ASCIZ = Directory.Search$ + CHR$(0)
  
	 ' reset delete flag
	 Delete.File = True

	 ' make directory name
	 Directory.Delete$ = Directory.Search$
	 IF Windows.Detected = False THEN
	    Directory.Delete$ = UCASE$(Directory.Delete$)
	 END IF

	 ' check delete type
	 IF Prompt.Delete = False THEN
	    Prompt$ = "Delete directory " + Directory.Delete$ + "(y/n/q)?"
	    CALL MorePrompt(Prompt$, "ynq", Outpt$)
	    IF BreakIS THEN
	       Outpt$ = "q"
	    END IF
	    SELECT CASE Outpt$
	    CASE "n"
	       Delete.File = False
	    CASE "q"
	       Delete.File = False
	       Quit.Searching = True
	    END SELECT
	 END IF

	 ' check delete flag
	 IF Delete.File THEN
	    ' check windows dos
	    IF Windows.Detected THEN
	       ' delete directory
	       InregsX.AX = &H713A
	       InregsX.DS = VARSEG(ASCIZ)
	       InregsX.DX = VARPTR(ASCIZ)
	       CALL InterruptX(&H21, InregsX, OutregsX)
	    ELSE
	       ' delete directory
	       InregsX.AX = &H3A00
	       InregsX.DS = VARSEG(ASCIZ)
	       InregsX.DX = VARPTR(ASCIZ)
	       CALL InterruptX(&H21, InregsX, OutregsX)
	    END IF

	    ' display any errors
	    CALL DisplayError("Error deleting directory.")

	    ' check carry flag error
	    IF (OutregsX.Flags AND &H1) = &H0 THEN
	       ' display search filename
	       COLOR Yellow, Black
	       PRINT Directory.Delete$
	    END IF
	 END IF
      END IF

      ' check search filename
      IF Command.Line = NUL THEN
	 EXIT DO
      END IF

      ' check quit searching
      IF Quit.Searching THEN
	 EXIT DO
      END IF
   LOOP

   ' check search filename
   IF Standard.Input$ = NUL THEN
      EXIT DO
   END IF

   ' check quit searching
   IF Quit.Searching THEN
      EXIT DO
   END IF
LOOP

End.Deldir:

' restore basic dta
InregsX.AX = &H1A00
InregsX.DS = BASIC.DTA.SEG
InregsX.DX = BASIC.DTA.OFF
CALL InterruptX(&H21, InregsX, OutregsX)

' restore current drive
InregsX.AX = &HE00
InregsX.DX = Current.Drive
CALL InterruptX(&H21, InregsX, OutregsX)

' display end program
IF Continuous.Display = False THEN
   Prompt$ = "Press <enter> to exit to DOS:"
   CALL MorePrompt(Prompt$, CHR$(13), Outpt$)
END IF
COLOR Plain, Black
END

' display program usage
Boot.Usage:
 ' make header
 COLOR White, Black
 PRINT "Deldir v1.1a: Directory delete utility; "
 COLOR Yellow, Black
 PRINT "Usage:"
 PRINT "   Deldir [d:]\path\ [/cpz]"
 PRINT "Where:"
 PRINT "   /c  continuous display"
 PRINT "   /p  don't prompt defore delete"
 PRINT "   /z  suppress error messages"
 COLOR Plain, Black
 END

Boot.Error:
 COLOR White, Black
 PRINT "Command line error. Type Deldir /? for help."
 COLOR Plain, Black
 END

' make header
Header:
 IF Header.Flag THEN
    RETURN
 END IF
 Header.Flag = True
 IF Continuous.Display = False THEN
    COLOR White, Black
    PRINT "Deldir v1.1a: Directory delete utility; "
 END IF
 RETURN

' critical error trap
Error.Routine:
 Data.Error = ERR
 IF Display.Errors THEN
    Error.Level = True
    OutregsX.Flags = &H1
    RESUME NEXT
 END IF
 SELECT CASE Data.Error
 CASE 53
    Temp.Outpt$ = "File not found."
 CASE 61
    Temp.Outpt$ = "Disk full."
 CASE 70
    Temp.Outpt$ = "Permission denied."
 CASE 71
    Temp.Outpt$ = "Disk not ready."
 CASE ELSE
    Temp.Outpt$ = "Untrapped error" + STR$(Data.Error) + "."
 END SELECT
 COLOR Green, Black
 PRINT Temp.Outpt$
 Prompt$ = "Press R to retry, Q to quit, C to continue:"
 CALL MorePrompt(Prompt$, "rqc", Outpt$)
 IF BreakIS THEN
    Outpt$ = "q"
 END IF
 SELECT CASE Outpt$
 CASE "r"
    RESUME
 CASE "q"
    Error.Level = True
    RESUME End.Deldir
 CASE "c"
    OutregsX.Flags = &H1
    RESUME NEXT
 END SELECT
 END 0

' checks Control-Break flag
FUNCTION BreakIS
 STATIC Var AS INTEGER
 IF KeyIS THEN
    IF OutregsX.AX = 0 THEN
       Var = True
    END IF
 END IF
 IF Var THEN
    Continuous.Display = True
 END IF
 BreakIS = Var
END FUNCTION

' clears Control-Break flag
FUNCTION ClearBreak
 DEF SEG = &H40
 POKE &H71, &H0
 DEF SEG
 ClearBreak = True
END FUNCTION

' displays carry flag error
SUB DisplayError (Temp$)
 ' check carry flag error
 IF (OutregsX.Flags AND &H1) = &H1 THEN
    ' check display errors flag
    IF Display.Errors = False THEN
       ' display error
       COLOR Red, Black
       PRINT Temp$
    END IF
 END IF
END SUB

' checks keyboard buffer
FUNCTION KeyIS
 InregsX.AX = &H100
 CALL InterruptX(&H16, InregsX, OutregsX)
 IF (OutregsX.Flags AND &H40) = &H40 THEN
    KeyIS = False
 ELSE
    KeyIS = True
 END IF
END FUNCTION

SUB MorePrompt (Input.String$, Input.Mask$, Output.String$)
 COLOR White, Black
 PRINT Input.String$ + " ";
 Input.Char$ = NUL
 DO
    LOCATE , , 1
    DO
       IF BreakIS THEN
	  EXIT DO
       END IF
       IF KeyIS THEN
	  IF OutregsX.AX <> 0 THEN
	     InregsX.AX = &H0
	     CALL InterruptX(&H16, InregsX, OutregsX)
	     Input.Char$ = CHR$(OutregsX.AX AND &HFF)
	     EXIT DO
	  END IF
       END IF
    LOOP
    IF BreakIS THEN
       EXIT DO
    END IF
    IF LEN(Input.Char$) THEN
       Input.Char$ = LCASE$(Input.Char$)
       IF INSTR(Input.Mask$, Input.Char$) THEN
	  PRINT Input.Char$
	  Output.String$ = Input.Char$
	  EXIT DO
       END IF
    END IF
 LOOP
END SUB

' command line parser
FUNCTION ParseLine (X$)
 Imbedded = INSTR(Command.Line, LCASE$(X$))
 IF Imbedded THEN
    Command.Line = LEFT$(Command.Line, Imbedded - 1) + MID$(Command.Line, Imbedded + LEN(X$))
    ParseLine = True
 ELSE
    Imbedded = INSTR(Command.Line, UCASE$(X$))
    IF Imbedded THEN
       Command.Line = LEFT$(Command.Line, Imbedded - 1) + MID$(Command.Line, Imbedded + LEN(X$))
       ParseLine = True
    ELSE
       ParseLine = False
    END IF
 END IF
END FUNCTION

