''''''''''''''''''''''''''''''''''''''
' Program    : Plays AVI Files       '
' Name       : OPENAVI Version 0.1   '
' Programmer : Yousuf Philips        '
' Company    : Y P I                 '
' Updated On : 18th of Sept. 1998    '
' Email - [philipz85@hotmail.com]    '
' [http://members.xoom.com/Philipz/] '
''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 1998 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to play AVI files. After creating the Ultimate BMP loader */'
'/* for BASIC (OPENBMP Version 0.4), YPI started to create an AVI player   */'
'/* because an uncompressed AVI is really a group of BMPs shown one after  */'
'/* the other to give an animation type look. This program is able to play */'
'/* uncompressed AVI files at the moment. It will work with any size AVI   */'
'/* file but it is better to play an AVI which is less than 321 X 201      */'
'/* because that's the size of SCREEN 13.                                  */'

'/* An original program created by the professional programmers at YPI.    */'
'/* If you use any of this code in your program then you must credit YPI.  */'
'/* This program has been placed in Public Domain and All Rights Are Reserved.*/'

'/* YPI has also created a BMP loader, PCX loader and an FLI player. The   */'
'/* source can be gotten from our website <http://members.xoom.com/Philipz/>*/'
'/* The YPI Website has programs for beginners, tutorials and utilities.   */'

DECLARE SUB ShowAVI (FileName$)
DECLARE SUB GetSpeed ()
DECLARE SUB delay (MiliSeconds%)

TYPE AVIHeader
   ValidID AS STRING * 4
   Reserved2 AS LONG
   MicrosecPerFrame AS LONG       '/* Number of Milliseconds between each Frame
   MaximumBytesPerSec AS LONG     '/* Number of bytes the system must handle
                                  '/* per second for the avi to run smoothly
   Reserved1 AS LONG              '/* Reserved must be 0
   BitFlags AS LONG               '/* Bit Flags
   TotalFrames AS LONG            '/* Total Number of Frames
   InitialFrame AS LONG           '/* Not Understood
   NoOfStreams AS LONG            '/* Number of Streams
   BufferSize AS LONG             '/* Buffer size to read a frame
   Widthz AS LONG                 '/* Width of AVI
   Heightz AS LONG                '/* Height of AVI
   Scale AS LONG                  '/* Not Understood
   Rate AS LONG                   '/* Not Understood
   Start AS LONG                  '/* Not Understood
   Length AS LONG                 '/* Not Understood
END TYPE

TYPE StreamHeader
    HeaderID AS STRING * 4
    Junk2 AS LONG
    Typez AS STRING * 4
    Handle AS STRING * 4
    BitFlags AS LONG
    Reserved1 AS LONG
    InitialFrames AS LONG
    Scale AS LONG
    Rate AS LONG
    Start AS LONG
    Length AS LONG
    BufferSize AS LONG
    Quality AS LONG
    SampleSize AS LONG
END TYPE

TYPE StreamFormat
    StreamFormatID AS STRING * 4
    Junk1 AS LONG
END TYPE

TYPE StreamCreater
    StreamCreaterID AS STRING * 4
    NumberOfCharacters AS LONG
END TYPE

TYPE JunkChunk
   ChunkID AS STRING * 4
   EmptyCharacters AS LONG
END TYPE

TYPE BMPInfoHeader
    LengthOfHeader AS LONG
    ImageWidth AS LONG
    ImageHeight AS LONG
    Planes AS INTEGER
    BitsPerPixel AS INTEGER
    CompressMethod AS LONG
    ImageSizeInBytes AS LONG
    HorizontalRatio AS LONG
    VerticalRatio AS LONG
    ColorsUsed AS LONG
    ImportantColors AS LONG
END TYPE

DIM SHARED Speed&

TYPE ImageData
   ChunkID AS STRING * 4
   NumberOfBytes AS LONG
END TYPE

TYPE ChangingPalette
   FirstColor AS STRING * 1
   NumberOfColorsToChange AS STRING * 1
   BitFlags AS INTEGER
END TYPE

GetSpeed
CLS
PRINT
FileName$ = COMMAND$
IF LEN(LTRIM$(FileName$)) = 0 THEN
   END
ELSEIF INSTR(FileName$, ".") = 0 THEN
   FileName$ = FileName$ + ".avi"
END IF

CALL ShowAVI(FileName$)
Wait$ = INPUT$(1)

SUB delay (MiliSeconds%)
'/* This function slows down your program for the given amount of Miliseconds */'
IF Speed& = 0 THEN
   PRINT " First run the GetSpeed sub"
   EXIT SUB
ELSEIF MiliSeconds% < 1 THEN
   PRINT " The sub needs a number greater than 0"
   EXIT SUB
END IF
DelayTime = (Speed& * 5) * (MiliSeconds% / 1000)
FOR Speed = 1 TO DelayTime
NEXT Speed

END SUB

SUB GetSpeed
'/* This function finds out the proper delay period needed for the current PC*/'
Time& = TIMER: Time& = Time& + 1: Speed& = 0
DO
LOOP UNTIL TIMER >= Time&
DO
   Speed& = Speed& + 1
LOOP UNTIL TIMER >= Time& + 1
Speed& = Speed& - (Speed& * .07)

END SUB

DEFINT A-Z
SUB ShowAVI (FileName$)

CLS
OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE #255
   KILL FileName$
   EXIT SUB
END IF

DIM AVIHead AS AVIHeader
DIM StreamHead AS StreamHeader
DIM StreamForm AS StreamFormat
DIM BMPInfoHead AS BMPInfoHeader
DIM ImageDataz AS ImageData
DIM ChangePalette AS ChangingPalette

GET #255, 25, AVIHead

Search1:
Position& = LOC(255) + 1: DWord$ = SPACE$(4)
DO
GET #255, Position&, DWord$
Position& = Position& + 4
LOOP UNTIL DWord$ = "LIST"
GET #255, , DWord$

GET #255, , DWord$
IF DWord$ = "strl" THEN
   GET #255, , StreamHead
   IF StreamHead.Typez <> "vids" THEN
      Searchz = Searchz + 1
      IF Searchz > 2 THEN
         PRINT " AVI HAS MORE 2 STREAMS WHICH ARENT VIDEO STREAMS"
         EXIT SUB
      END IF
      GOTO Search1
   END IF
   Position& = LOC(255) + 1
   DO
      GET #255, Position&, DWord$
      Position& = Position& + 4
   LOOP UNTIL DWord$ = "strf"
   GET #255, Position& - 4, StreamForm
   GET #255, , BMPInfoHead
   IF BMPInfoHead.BitsPerPixel <> 8 THEN
      PRINT " PROGRAM CAN ONLY RUN 8-BIT AVIs"
      EXIT SUB
   END IF
   IF BMPInfoHead.CompressMethod <> 0 THEN
      PRINT " PROGRAM CAN ONLY PLAY UNCOMPRESSED AVIs"
      EXIT SUB
   END IF
   Palette$ = SPACE$(1024)
   GET #255, , Palette$
   SCREEN 13
   FOR Loops = 0 TO 255
      OUT &H3C8, Loops
      OUT &H3C9, INT(ASC(MID$(Palette$, (Loops * 4) + 3, 1)) / 4)
      OUT &H3C9, INT(ASC(MID$(Palette$, (Loops * 4) + 2, 1)) / 4)
      OUT &H3C9, INT(ASC(MID$(Palette$, (Loops * 4) + 1, 1)) / 4)
   NEXT Loops
ELSE
   PRINT " UNABLE TO USE AVI FILE"
   EXIT SUB
END IF

Search:
Position& = LOC(255) + 1
DO
GET #255, Position&, DWord$
Position& = Position& + 4
LOOP UNTIL DWord$ = "LIST"
GET #255, , DWord$

GET #255, , DWord$
IF DWord$ = "movi" THEN
   IF 4 - (BMPInfoHead.ImageWidth MOD 4) = 4 THEN
      Bytes$ = SPACE$(BMPInfoHead.ImageWidth)
   ELSE
      Bytes$ = SPACE$(BMPInfoHead.ImageWidth + (4 - (BMPInfoHead.ImageWidth MOD 4)))
   END IF
   FOR FrameNumber = 1 TO AVIHead.TotalFrames
      GET #255, , ImageDataz
      IF RIGHT$(ImageDataz.ChunkID, 2) = "db" THEN
         FOR YHeight = BMPInfoHead.ImageHeight - 1 TO 0 STEP -1
             GET #255, , Bytes$
             FOR XWidth = 0 TO BMPInfoHead.ImageWidth - 1
                 PSET (XWidth, YHeight), ASC(MID$(Bytes$, XWidth + 1, 1))
             NEXT XWidth
         NEXT YHeight
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "pc" THEN
         '/* Skipping the color changing                                   */'
         'GET #255, , ChangePalette
         'GET #255, , Palette$
         SEEK #255, LOC(255) + 1 + ImageDataz.NumberOfBytes
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "wb" THEN
         '/* Skipping the sound part of the avi if there is.               */'
         SEEK #255, LOC(255) + 1 + ImageDataz.NumberOfBytes
         FrameNumber = FrameNumber - 1
      ELSEIF RIGHT$(ImageDataz.ChunkID, 2) = "dc" THEN
         SCREEN 2: SCREEN 0
         PRINT " ONLY UNCOMPRESSED AVI SEQUENCIES CAN BE SHOWN"
         EXIT SUB
      ELSE
         SCREEN 2: SCREEN 0
         PRINT " SOMETHING IS WRONG"
         EXIT SUB
      END IF
      '/* If the program is to slow or fast on your PC then you should     */'
      '/* should change the number 1000 to a number which will suit your   */'
      '/* requirements.                                                    */'
      delay (1000 / AVIHead.TotalFrames)
   NEXT FrameNumber
ELSE
   GOTO Search
END IF

END SUB

