'    ______     _      _    ______     _            _____      ____
'   |   __  \  | \    | |  |   __  \  | |  _      /  ___  \   |  __ \
'   |  |__>  | |  \   | |  |  |__>  | | | | |    |  |   |  |  | |__| |
'   |  ____ /  | \ \  | |  |  ____ /  | |_| |__  |  |   |  |  |  _  /
'   | |        | |\ \ | |  | |        |___   __| |  |   |  |  | |  \ \
'   | |        | | \ \| |  | |            | |    |  |___|  |  | |__| |
'   |_|        |_|   \__|  |_|            |_|     \ ________| |_____/
'
'                             - Demonstration -
'                     Copyright 2000 (C) Sebastian Mate
'
' Program:     PNP4QB
' Description: The first AGP, PCI and Plug'n'Play detector for QB!
'              Detect hundreds of devices, cards and chipsets!
' Author:      Sebastian Mate (jmate@t-online.de, http://www.sm-gimi.de)
' Version:     1.00 (1)
' Edition:     1
'
' 1. Warranty
' -----------
' The programmer assumes no responsibility for any harm or costs
' that comes from using the material contained in these files and to
' you, your computer, or anything relating to your existence. No
' warranty is provided or implied on these files!
' This file is provided as is.
'
' 2. Trademarks
' -------------
' All names and trademarks belong to their owners.
'
' 3. Documentation
' ----------------
' Please read README.TXT!


' ----------------------- Start of the sample-program --------------------

DECLARE SUB FRAME ()
COLOR 15, 7
SHELL "CODEPAGE.COM" ' Load default VGA-font
FRAME                ' Show frame

LOCATE 3, 3: COLOR 0, 7: PRINT "Detecting Hardware:"
LOCATE 5, 3: COLOR 0, 7: PRINT "Be sure to run this program in real DOS. Otherwise your computer may"
LOCATE 6, 3: COLOR 0, 7: PRINT "crash or can't detect any PnP-hardware!"
LOCATE 8, 3: COLOR 0, 7: PRINT "Detecting PCI ...": COLOR 15, 7:
 SHELL "REN PCI.DAT PCI.EXE"
 SHELL "PCI.EXE > PCI.INI"
 SHELL "REN PCI.EXE PCI.DAT"

LOCATE 9, 3: COLOR 0, 7: PRINT "Detecting Plug-and-Play ...": COLOR 15, 7:
 SHELL "REN PNP.DAT PNP.EXE"
 SHELL "PNP.EXE > PNP.INI"
 SHELL "REN PNP.EXE PNP.DAT"

DO
 FRAME
 PRINT
 LOCATE 3, 3: COLOR 15, 1: PRINT " PCI/AGP Devices ": COLOR 15, 7:
 PRINT
 OPEN "PCI.INI" FOR INPUT AS #1
 COLOR 12, 7
 DO

  LINE INPUT #1, S$

  IF MID$(S$, 1, 8) = "PCIBIOS=" THEN
     BIOSVER$ = MID$(S$, 9, LEN(S$))
     LOCATE , 3: PRINT "PCI BIOS version: "; BIOSVER$
  END IF

  IF MID$(S$, 1, 10) = "PCIBUSSES=" THEN
     BIOSVER$ = MID$(S$, 11, LEN(S$))
     LOCATE , 3: PRINT "Number of PCI-busses: "; BIOSVER$
  END IF

 LOOP WHILE NOT EOF(1)

 CLOSE
 
 PRINT : OPEN "PCI.INI" FOR INPUT AS #1
 DO

  LINE INPUT #1, S$

  IF MID$(S$, 1, 7) = "VENDOR=" THEN
     VENDOR$ = MID$(S$, 14, LEN(S$))
     LINE INPUT #1, S$
     DEVICE$ = MID$(S$, 14, LEN(S$))
        IF DEVICE$ <> LASTDEV$ OR VENDOR$ <> LASTVEN$ THEN
          LOCATE , 3: COLOR 0, 7: PRINT "........................................... "; : COLOR 15, 7: PRINT VENDOR$;
          LOCATE , 3: COLOR 14, 7: PRINT DEVICE$; " "
        END IF
     LASTVEN$ = VENDOR$
     LASTDEV$ = DEVICE$
  END IF

  IF CSRLIN > 23 THEN
    DO: S$ = INKEY$: LOOP UNTIL S$ <> ""
    IF S$ = CHR$(27) THEN COLOR 7, 0: CLS : SYSTEM
    FRAME
  END IF

 LOOP WHILE NOT EOF(1)

 CLOSE

 PRINT : LOCATE , 3: COLOR 15, 1: PRINT " Plug-and-Play System Hardware ": COLOR 15, 7
 PRINT

 OPEN "PNP.INI" FOR INPUT AS #1

 DO
 
  LINE INPUT #1, S$

  IF MID$(S$, 1, 8) = "PNPBIOS=" THEN
     BIOSVER$ = MID$(S$, 9, LEN(S$))
     LOCATE , 3: COLOR 12, 7: PRINT "PNP BIOS version: "; BIOSVER$: PRINT
  END IF
 
  IF MID$(S$, 1, 7) = "DEVICE=" THEN
     ID$ = MID$(S$, 8, 7)
     DEVICE$ = MID$(S$, 16, LEN(S$))
     LOCATE , 3: COLOR 15, 7: PRINT ID$; "  "; : COLOR 14, 7: PRINT DEVICE$
  END IF
 
  IF MID$(S$, 1, 7) = "ISA" THEN COLOR 15, 1: PRINT : LOCATE , 3: PRINT " ISA Plug-and-Play Hardware ": COLOR 15, 7: PRINT
 
  IF MID$(S$, 1, 14) = "LOGICALDEVICE=" THEN
     ID$ = MID$(S$, 15, 7)
     DEVICE$ = MID$(S$, 23, LEN(S$))
     LOCATE , 3: COLOR 15, 7: PRINT "         "; ID$; "  "; : COLOR 14, 7: PRINT DEVICE$
  END IF
 
  IF MID$(S$, 1, 10) = "COMDEVICE=" THEN
     ID$ = MID$(S$, 11, 7)
     DEVICE$ = MID$(S$, 19, LEN(S$))
     LOCATE , 3: COLOR 13, 7: PRINT "                  "; : COLOR 14, 7: PRINT DEVICE$
  END IF
 
  IF CSRLIN > 23 THEN
   DO: S$ = INKEY$: LOOP UNTIL S$ <> ""
   IF S$ = CHR$(27) THEN COLOR 7, 0: CLS : SYSTEM
   FRAME
  END IF

 LOOP WHILE NOT EOF(1)
   DO: S$ = INKEY$: LOOP UNTIL S$ <> ""
   IF S$ = CHR$(27) THEN COLOR 7, 0: CLS : SYSTEM
 CLOSE

LOOP

SUB FRAME
COLOR 0, 7
CLS
LOCATE 1, 1
COLOR 14, 1
COLOR 15, 1: PRINT " PNP4QB Version 1.0 -- Copyright 2000 Sebastian Mate                            "
COLOR 0, 7: PRINT "Ŀ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "                                                                              ";
PRINT "";
LOCATE 25, 1: COLOR 7, 1: PRINT " Hit any key for the next page  ESC Exit  more cool stuff on www.sm-gimi.de   ";
LOCATE 4, 1
END SUB

