DECLARE SUB LoadAsm ()
DECLARE SUB GetSpeed ()
DECLARE SUB ShowAVX (FileName$)
DECLARE SUB ShowAVI (FileName$, PaletteFile$)
DECLARE SUB BITZ24AVI (ImageWidth%, YHeight%, LineExtract$, BitsPerPixel%, StartX%, StartY%)
DECLARE SUB SetColor (ColorNumber%, Red%, Green%, Blue%)
DECLARE SUB Delay (MiliSeconds%)
DECLARE SUB DIBPlay (ImageWidth%, ImageHeight%, BitsPerPixel%)
DECLARE SUB MemCopy (FromSeg%, FromOff%, ToSeg%, ToOff%, Bytes%)
DECLARE SUB NearestWord (LongNo AS LONG)
DECLARE SUB RLECompression (ImageHeight AS LONG)
DECLARE SUB SaveBMP (FileName$)
''''''''''''''''''''''''''''''''''''''''''''''
' Program    : Qbasic AVI Player             '
' Name       : OpenAVI Version 1.0           '
' Programmer : Yousuf Philips                '
' Company    : Y P I [Philipz Inc.]          '
' Updated On : 1st of November 2000          '
' Email - philipz85@hotmail.com              '
' Website - http://bilalphilips.com/Philipz/ '
''''''''''''''''''''''''''''''''''''''''''''''

'/*               Do not edit this file if you distribute it.              */'
'/*  (c) Copyrighted by YPI in 2000 | All Rights Reserved | Public Domain  */'

'/* This program has been created by YPI (Basic Programming Incorporation) */'
'/* as a utility to play AVI files in QBASIC.                              */'
'/*                                                                        */'
'/* What's New -                                                           */'
'/*            * Source code was re-written from scratch to improve        */'
'/*              performance as well as become fully compatible with       */'
'/*              all Windows compatible AVI files                          */'
'/*            * Displays 8, 16 and 24-bit uncompressed AVIs in            */'
'/*              full-color (Screen 13)                                    */'
'/*            * Displays 8-bit RLE compressed AVIs                        */'
'/*            * Plays 8-bit uncompressed and RLE compressed AVIs          */'
'/*              with uncompressed 8 or 16-bit audio sequences             */'
'/*            * Audio sequences can be mono or stereo and 8khz to 44khz   */'
'/*            * 16 or 24-bit uncompressed AVIs are converted to an        */'
'/*              8-bit AVX file, which can be displayed very quickly       */'
'/*            * Audio playing routines are include in a separate file     */'
'/*              for individuals who wish to remove the audio playing      */'
'/*              source code from the player.                              */'
'/*            * Built and compilable with Qbasic 4.5+                     */'

'/* I would like to take this moment to credit Toshi and Mike who made     */'
'/* DMAPLAYX.BAS, which I modified for the playing of audio sequences in   */'
'/* this program. OpenAVI v0.6 used the audio playing routines of          */'
'/* WAVPLAY.BAS but the routines were very limited and weren't able to play*/'
'/* with all sound cards as well as not being able to play audio which     */'
'/* wasn't 11Khz. DMAPLAYX.BAS could play 8 and 16 bit audio which is mono */'
'/* or stereo from 8Khz to 44Khz.                                          */'

'/* If you use any of this code in your program then you must credit YPI,  */'
'/* it would be appreciated if you sent us a copy of your program also.    */'
'/* Please send your comments and suggestions to <philipz85@hotmail.com>   */'

DEFINT A-Z
'$INCLUDE: 'aviplay.bi'
'$DYNAMIC
DIM SHARED ASM AS STRING * 40, Speed&, DB&
DIM SHARED ColorPalArray(255, 3), ColorsInArray, Variation

CALL LoadAsm
SCREEN 2: SCREEN 0: CLS
GetSpeed
CLS
ON ERROR GOTO Erroz
PRINT
PRINT "  Qbasic AVI Player - OpenAVI ver 1.0"
PRINT "  (c) YPI (BASIC Programming Incorporation) 1999-2000"
PRINT "  Press Any Key When You Want The AVI To Stop Playing"
PRINT "  Download Examples From http://bilalphilips.com/Philipz/"
FILES "*.avi"
FILES "*.avx"
INPUT "  Enter File Name - ", FileName$

IF LCASE$(RIGHT$(FileName$, 3)) = "avx" THEN
   CALL ShowAVX(FileName$)
ELSEIF LCASE$(RIGHT$(FileName$, 3)) = "avi" THEN
   CALL ShowAVI(FileName$, "")
END IF
END

Erroz:
RESUME NEXT

REM $STATIC
SUB BITZ24AVI (ImageWidth, YHeight, LineExtract$, BitsPerPixel, StartX, StartY)

IF BitsPerPixel = 16 THEN
   BytesMultiple = 2
ELSEIF BitsPerPixel = 24 THEN
   BytesMultiple = 3
END IF

FOR XWidth = 0 TO ImageWidth - 1
   XWidthPosition = XWidth * BytesMultiple
   IF BitsPerPixel = 16 THEN
      ColorPalette = CVI(MID$(LineExtract$, XWidthPosition + 1, 2))
      PixelBlue = (ColorPalette AND 31) * 2
      PixelGreen = ((ColorPalette \ 32) AND 31) * 2
      PixelRed = ((ColorPalette AND 31744) \ 1024) * 2
   ELSEIF BitsPerPixel = 24 THEN
      PixelBlue = ASC(MID$(LineExtract$, XWidthPosition + 1, 1)) \ 4
      PixelGreen = ASC(MID$(LineExtract$, XWidthPosition + 2, 1)) \ 4
      PixelRed = ASC(MID$(LineExtract$, XWidthPosition + 3, 1)) \ 4
   END IF

   PixelSet = 0
   FOR Loops = 0 TO ColorsInArray
      IF PixelBlue >= ColorPalArray(Loops, 3) - Variation AND PixelBlue <= ColorPalArray(Loops, 3) + Variation THEN
         IF PixelGreen >= ColorPalArray(Loops, 2) - Variation AND PixelGreen <= ColorPalArray(Loops, 2) + Variation THEN
            IF PixelRed >= ColorPalArray(Loops, 1) - Variation AND PixelRed <= ColorPalArray(Loops, 1) + Variation THEN
               PSET (StartX + XWidth, StartY + YHeight), Loops
               PixelSet = 1
               EXIT FOR
            END IF
         END IF
      END IF
   NEXT Loops
  
   IF PixelSet = 0 THEN
      IF ColorsInArray < 255 THEN
         ColorsInArray = ColorsInArray + 1
         ColorPalArray(ColorsInArray, 1) = PixelRed
         ColorPalArray(ColorsInArray, 2) = PixelGreen
         ColorPalArray(ColorsInArray, 3) = PixelBlue
         CALL SetColor(ColorsInArray, PixelRed, PixelGreen, PixelBlue)
         PSET (StartX + XWidth, StartY + YHeight), ColorsInArray
      ELSE
         IF DB& = 1 THEN EXIT SUB
         Movement = 0
         DO
            FOR Loops = 0 TO 255
               IF PixelBlue >= (ColorPalArray(Loops, 3) - Movement) AND PixelBlue <= (ColorPalArray(Loops, 3) + Movement) THEN
                  IF PixelGreen >= (ColorPalArray(Loops, 2) - Movement) AND PixelGreen <= (ColorPalArray(Loops, 2) + Movement) THEN
                     IF PixelRed >= (ColorPalArray(Loops, 1) - Movement) AND PixelRed <= (ColorPalArray(Loops, 1) + Movement) THEN
                        PSET (StartX + XWidth, StartY + YHeight), Loops
                        EXIT DO
                     END IF
                  END IF
               END IF
            NEXT Loops
            Movement = Movement + 1
         LOOP
      END IF
   END IF
NEXT XWidth

END SUB

DEFSNG A-Z
SUB Delay (MiliSeconds%)

DelayTime = (Speed& * 5) * (MiliSeconds% / 1000)
FOR Speed = 1 TO DelayTime
NEXT Speed

END SUB

DEFINT A-Z
SUB DIBPlay (ImageWidth, ImageHeight, BitsPerPixel)

StartY = (200 - ImageHeight) \ 2: StartX = (320 - ImageWidth) \ 2
ByteCopy = ImageWidth
IF ImageWidth > 320 THEN
   ByteCopy = 320
   StartByte = ABS(StartX)
   StartX = 0
END IF

Extract = (BitsPerPixel / 8) * ImageWidth
IF (Extract MOD 4) <> 0 THEN Extract = Extract + (4 - (Extract MOD 4))
Extract$ = SPACE$(Extract)

LocationOfData& = LOC(255) + 1
DO
Restart = 0
SEEK #255, LocationOfData&
FOR YHeight = ImageHeight - 1 TO 0 STEP -1
   GET #255, , Extract$
   IF YHeight + StartY > 200 THEN
   ELSEIF BitsPerPixel = 8 THEN
      IF (YHeight + StartY) < 101 AND (YHeight + StartY) > -1 THEN
         CALL MemCopy(VARSEG(Extract$), SADD(Extract$) + StartByte, &HA000, (YHeight + StartY) * 320 + StartX, ByteCopy)
      ELSEIF (YHeight + StartY) < 201 AND (YHeight + StartY) > 99 THEN
         CALL MemCopy(VARSEG(Extract$), SADD(Extract$) + StartByte, &HA7D0, (YHeight + StartY - 100) * 320 + StartX, ByteCopy)
      END IF
   ELSEIF BitsPerPixel = 16 OR BitsPerPixel = 24 THEN
      CALL BITZ24AVI(INT(ImageWidth), YHeight, Extract$, BitsPerPixel, StartX, StartY)
      IF ColorsInArray = 255 AND DB& = 1 THEN
         Variation = Variation + 1
         LINE (0, 0)-(320, 200), 0, BF
         Restart = 1
         ColorsInArray = 0
         EXIT FOR
      END IF
   END IF
NEXT YHeight
LOOP UNTIL Restart = 0

END SUB

DEFSNG A-Z
SUB GetSpeed

PRINT " One Moment Please [Performing Some Calculations]"
Time& = TIMER: Time& = Time& + 1: Speed& = 0
DO
LOOP UNTIL TIMER >= Time&
DO
   Speed& = Speed& + 1
LOOP UNTIL TIMER >= Time& + 1

Time! = TIMER
Delay 1000
Time! = TIMER - Time!

IF Time! < 1 THEN
   Speed& = INT(Speed& * (1 / Time!))
END IF

END SUB

DEFINT A-Z
SUB LoadAsm

OPEN "avi.asm" FOR BINARY AS #1
   IF LOF(1) <> 40 THEN PRINT " Unable to Load Assembly Code": CLOSE #1: END
   GET #1, , ASM
CLOSE #1

END SUB

SUB MemCopy (FromSeg, FromOff, ToSeg, ToOff, Bytes)

DEF SEG = VARSEG(ASM)
  CALL ABSOLUTE(BYVAL FromSeg, BYVAL FromOff, BYVAL ToSeg, BYVAL ToOff, BYVAL Bytes, VARPTR(ASM))
DEF SEG

END SUB

SUB NearestWord (LongNo AS LONG)
IF (LongNo MOD 2) = 1 THEN LongNo = LongNo + 1
END SUB

SUB RLECompression (ImageHeight AS LONG)

PixelColors$ = SPACE$(1): NoOfSameColors$ = SPACE$(1)
RightMovement$ = SPACE$(1): UpMovement$ = SPACE$(1)
X = 0: Y = ImageHeight - 1
DO
   GET #255, , NoOfSameColors$
   GET #255, , PixelColors$
   NoOfSameColors = ASC(NoOfSameColors$)
   PixelColor = ASC(PixelColors$)

   IF NoOfSameColors <> 0 THEN
      LINE (X, Y)-STEP(ASC(NoOfSameColors$) - 1, 0), PixelColor
      X = X + NoOfSameColors
   ELSEIF NoOfSameColors = 0 AND PixelColor = 0 THEN
      X = 0: Y = Y - 1
   ELSEIF NoOfSameColors = 0 AND PixelColor = 1 THEN
      EXIT DO
   ELSEIF NoOfSameColors = 0 AND PixelColor = 2 THEN
      GET #255, , RightMovement$
      GET #255, , UpMovement$
      X = X + ASC(RightMovement$): Y = Y - ASC(UpMovement$)
   ELSEIF NoOfSameColors = 0 THEN
      PixelColor$ = SPACE$(PixelColor)
      GET #255, , PixelColor$
      IF Y < 101 AND Y > -1 THEN
         CALL MemCopy(VARSEG(PixelColor$), SADD(PixelColor$), &HA000, (Y * 320) + X, PixelColor)
      ELSEIF Y < 201 AND Y > 100 THEN
         CALL MemCopy(VARSEG(PixelColor$), SADD(PixelColor$), &HA7D0, ((Y - 100) * 320) + X, PixelColor)
      END IF
      X = X + PixelColor
      IF (PixelColor MOD 2) = 1 THEN GET #255, , NoOfSameColors$
   END IF
LOOP

END SUB

SUB SaveBMP (FileName$)

DIM Pixels(0) AS STRING * 320

OPEN FileName$ FOR BINARY AS #2
SEEK #2, LOF(2) + 1

FOR YHeight = 0 TO 199
   IF YHeight < 101 THEN
      CALL MemCopy(&HA000, YHeight * 320, VARSEG(Pixels(0)), VARPTR(Pixels(0)), 320)
   ELSEIF YHeight > 99 THEN
      CALL MemCopy(&HA7D0, (YHeight - 100) * 320, VARSEG(Pixels(0)), VARPTR(Pixels(0)), 320)
   END IF
   PUT #2, , Pixels(0)
   'LINE (0, YHeight)-(319, YHeight), 0
NEXT YHeight
CLOSE #2
ERASE Pixels

END SUB

SUB SetColor (ColorNumber, Red, Green, Blue)

OUT &H3C8, ColorNumber
OUT &H3C9, Red
OUT &H3C9, Green
OUT &H3C9, Blue

END SUB

SUB ShowAVI (FileName$, PaletteFile$)

DIM RIFFHeaderType AS RIFFHeaderType
DIM Chunk AS Chunk
DIM ListChunk AS ListChunk
DIM ListChunk1 AS ListChunk
DIM AVIHeader AS AVIHeader
DIM StreamHeader AS StreamHeader
DIM StreamFormat AS StreamFormat
DIM BMPInfoHead AS BMPInfoHeader
DIM ImageData AS ImageData
DIM WavHeader AS WavHeader
DIM Idx1Entries AS Idx1Entries
DIM Palette8(0) AS STRING * 1024
DIM OneByte AS STRING * 1
DIM WaveBuffer(0) AS STRING

CLS
OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE #255: KILL FileName$: EXIT SUB
END IF

GET #255, , RIFFHeaderType
IF RIFFHeaderType.RIFFFileType <> "AVI " THEN
   PRINT " Invalid AVI File"
   CLOSE #255: EXIT SUB
END IF

DO
   ChunkStartPosition# = LOC(255) + 1
   GET #255, , ListChunk
   IF ListChunk.ListID = "LIST" THEN
      CALL NearestWord(ListChunk.BytesInList)
      IF ListChunk.ListType = "hdrl" THEN
         GET #255, , AVIHeader
         IF AVIHeader.ValidID <> "avih" THEN
            PRINT " AVI Header Not Found"
            CLOSE #255: EXIT SUB
         ELSEIF AVIHeader.Size <> 56 THEN
            SEEK #255, LOC(1) + 1 + (AVIHeader.Size - 56)
         END IF
         AVIHeader.MicrosecPerFrame = AVIHeader.MicrosecPerFrame \ 1000
         FramesPerSecond = CINT(1000 / AVIHeader.MicrosecPerFrame)

         FOR StreamNumber = 1 TO AVIHeader.NoOfStreams
            GET #255, , ListChunk1
            IF ListChunk1.ListType = "strl" THEN
               StreamHeaderPosition# = LOC(255) + 1
               GET #255, , StreamHeader
               IF StreamHeader.HeaderID = "strh" THEN
                  CALL NearestWord(StreamHeader.BytesIn)
                  IF StreamHeader.Typez = "vids" THEN
                     Video$ = " Video - " + StreamHeader.Handle
                     VideoHandle$ = StreamHeader.Handle
                  ELSEIF StreamHeader.Typez = "auds" THEN
                     Audio$ = " Audio - " + StreamHeader.Handle
                     AudioHandle$ = StreamHeader.Handle
                  ELSEIF StreamHeader.Typez = "pads" THEN
                  ELSE
                     PRINT " Unknown Stream Type "; StreamHeader.Typez
                     CLOSE #255: EXIT SUB
                  END IF
                  SEEK #255, StreamHeaderPosition# + 8 + StreamHeader.BytesIn
                  GET #255, , StreamFormat
                  StreamFormatPosition# = LOC(255) + 1
                  CALL NearestWord(StreamFormat.BytesIn)
                  IF StreamFormat.ID <> "strf" THEN
                     PRINT " Stream Format Not Found"
                     CLOSE #255: EXIT SUB
                  END IF
                  IF StreamHeader.Typez = "vids" THEN
                     GET #255, , BMPInfoHead
                     IF BMPInfoHead.BitsPerPixel < 8 THEN
                        PRINT " Can't Play AVI File [Bits Per Pixel < 8]"
                        CLOSE #255: EXIT SUB
                     ELSEIF BMPInfoHead.BitsPerPixel = 32 THEN
                        PRINT " Can't Play AVI File [32-Bits Per Pixel]"
                        CLOSE #255: EXIT SUB
                     END IF
                     IF BMPInfoHead.BitsPerPixel = 8 THEN
                        IF BMPInfoHead.ImageWidth > 320 OR BMPInfoHead.ImageHeight > 200 THEN
                           PRINT " Can't Play AVI File Larger Than 320 X 200"
                           CLOSE #255: EXIT SUB
                        END IF
                        GET #255, , Palette8(0)
                     ELSEIF BMPInfoHead.BitsPerPixel = 16 OR BMPInfoHead.BitsPerPixel = 24 THEN
                        Variation = 4
                     END IF
                  ELSEIF StreamHeader.Typez = "auds" THEN
                     GET #255, , WavHeader
                     IF WavHeader.BytesPerSecond < 32767 THEN
                        IF StartSoundBlaster = 0 THEN
                           PlayingWave = 1
                        ELSE
                           PRINT "Sound Blaster Couldn't Be Detected"
                           Junk$ = INPUT$(1)
                        END IF
                        WaveBuffer(0) = SPACE$(WavHeader.BytesPerSecond)
                     ELSE
                        PRINT "Unable To Play Audio."
                        Junk$ = INPUT$(1)
                     END IF
                  END IF
                  SEEK #255, StreamFormatPosition# + StreamFormat.BytesIn
                  GET #255, , Chunk
                  IF Chunk.ID = "strn" THEN
                     IF (Chunk.Bytes MOD 2) = 1 THEN
                        Chunk.Bytes = Chunk.Bytes + 1
                     END IF
                     FOR Loops = 1 TO Chunk.Bytes
                        GET #255, , OneByte
                        Creator$ = Creator$ + OneByte
                     NEXT Loops
                  ELSE
                     SEEK #255, LOC(255) - 7
                  END IF
                  DO
                    GET #255, , OneByte
                  LOOP WHILE OneByte <> "L"
                  SEEK #255, LOC(255)
               ELSE
                  PRINT " Error In AVI File [Stream Header Not Found]"; StreamHeader.HeaderID
                  CLOSE #255: EXIT SUB
               END IF
            ELSE
               PRINT " Error In AVI File [Stream List Not Found]"; ListChunk1.ListType
               CLOSE #255: EXIT SUB
            END IF
         NEXT StreamNumber
      ELSEIF ListChunk.ListType = "movi" THEN
         StartOfMovieChunk# = LOC(255) - 3
      ELSEIF ListChunk.ListType = "INFO" THEN
      END IF
   ELSEIF ListChunk.ListID = "idx1" THEN
      IndexChunkEntries = ListChunk.BytesInList \ 16
      DIM IndexEntry(IndexChunkEntries) AS Idx1Entries
      SEEK #255, LOC(255) - 3
      FOR Loops = 1 TO IndexChunkEntries
         GET #255, , IndexEntry(Loops)
      NEXT Loops
      IndexFound = 1
      IF LCASE$(VideoHandle$) = "cvid" THEN
         PRINT " CVID - CinePak Compression Can't Be Displayed"
         CLOSE #255: EXIT SUB
      END IF
   ELSEIF ListChunk.ListID = "JUNK" THEN
   ELSEIF ListChunk.ListID = "DISP" THEN
   ELSEIF ListChunk.ListID = STRING$(4, 0) THEN
      EXIT DO
   ELSE
      IF IndexFound <> 1 THEN
         PRINT " Error Obtained In AVI File"
         CLOSE #255: EXIT SUB
      ELSE
         EXIT DO
      END IF
   END IF
   SEEK #255, ChunkStartPosition# + 8 + ListChunk.BytesInList
LOOP UNTIL LOC(255) + 1 >= LOF(255)

IF IndexFound = 0 THEN
   PRINT " The AVI Index Isn't Present [Can't Play AVI]."
   CLOSE #255: EXIT SUB
ELSE
   PRINT "  - AVI Information -"
   PRINT "  Width of AVI Images -"; BMPInfoHead.ImageWidth
   PRINT "  Height of AVI Images -"; BMPInfoHead.ImageHeight
   PRINT "  Image Depth Per Pixel -"; BMPInfoHead.BitsPerPixel
   PRINT "  Frames In AVI -"; AVIHeader.TotalFrames
   PRINT "  AVI File Has - ";
   IF AVIHeader.NoOfStreams = 1 THEN
      PRINT " Audio or Video"
   ELSEIF AVIHeader.NoOfStreams = 2 THEN
      PRINT " Audio & Video"
   ELSE
      PRINT " Unknown Streams"
      CLOSE #255: EXIT SUB
   END IF
   PRINT
   PRINT "  Press Any Key To Play AVI Image"
   WHILE INKEY$ <> "": WEND
   Wait$ = INPUT$(1)

   IF BMPInfoHead.BitsPerPixel = 8 THEN
      SCREEN 13
      OUT &H3C8, 0
      FOR Loops = 0 TO 255
         OUT &H3C9, ASC(MID$(Palette8(0), (Loops * 4) + 3, 1)) \ 4
         OUT &H3C9, ASC(MID$(Palette8(0), (Loops * 4) + 2, 1)) \ 4
         OUT &H3C9, ASC(MID$(Palette8(0), (Loops * 4) + 1, 1)) \ 4
      NEXT Loops
   ELSE
      SecondFile$ = LEFT$(FileName$, LEN(FileName$) - 3) + "avx"
      OPEN SecondFile$ FOR BINARY AS #1
         IF LOF(1) <> 0 THEN
            PRINT "  " + UCASE$(SecondFile$) + " is not empty. Do you wish to overwrite the file [Y/N]"
            DO
               KeyPressed$ = INPUT$(1)
               IF KeyPressed$ = "N" OR KeyPressed$ = "n" THEN
                  CLOSE #1
                  CLOSE #255
                  EXIT SUB
               END IF
            LOOP UNTIL KeyPressed$ = "Y" OR KeyPressed$ = "y"
            CLOSE #1
            KILL SecondFile$
            OPEN SecondFile$ FOR BINARY AS #1
         END IF
         Frames$ = MKL$(AVIHeader.TotalFrames)
         Microsec$ = MKL$(AVIHeader.MicrosecPerFrame)
         PUT #1, , Frames$
         PUT #1, , Microsec$
         PUT #1, , Palette8(0)
      CLOSE #1
      SCREEN 13
   END IF

   DO
      DB = 0
      FOR Loops = 1 TO IndexChunkEntries
         SEEK #255, StartOfMovieChunk# + IndexEntry(Loops).OffsetOfData + 8
         t# = TIMER
         IF IndexEntry(Loops).ID = "rec " THEN
         ELSEIF RIGHT$(IndexEntry(Loops).ID, 2) = "db" THEN
            DB& = DB& + 1
            IF LCASE$(VideoHandle$) = "mrle" OR LCASE$(VideoHandle$) = "rle " THEN
               CALL RLECompression(BMPInfoHead.ImageHeight)
            ELSE
               WAIT &H3DA, 8
               CALL DIBPlay(INT(BMPInfoHead.ImageWidth), INT(BMPInfoHead.ImageHeight), INT(BMPInfoHead.BitsPerPixel))
            END IF
            IF PlayingWave = 1 AND ExtractWave = 1 THEN
               CALL PlayWaveAudio(VARSEG(WaveBuffer(0)), SADD(WaveBuffer(0)), WavHeader.Channels, WavHeader.BytesPerSecond, WavHeader.BitsPerSample, WavePlaySize&)
               ExtractWave = 0
            END IF
            IF BMPInfoHead.BitsPerPixel <> 8 THEN
               CALL SaveBMP(SecondFile$)
               Exiting$ = "Exits"
            END IF
         ELSEIF RIGHT$(IndexEntry(Loops).ID, 2) = "dc" THEN
            IF LCASE$(VideoHandle$) = "mrle" OR LCASE$(VideoHandle$) = "rle " THEN
               CALL RLECompression(BMPInfoHead.ImageHeight)
            END IF
            IF PlayingWave = 1 AND ExtractWave = 1 THEN
               CALL PlayWaveAudio(VARSEG(WaveBuffer(0)), SADD(WaveBuffer(0)), WavHeader.Channels, WavHeader.BytesPerSecond, WavHeader.BitsPerSample, WavePlaySize&)
               ExtractWave = 0
            END IF
         ELSEIF RIGHT$(IndexEntry(Loops).ID, 2) = "wb" THEN
            IF PlayingWave = 1 AND BMPInfoHead.BitsPerPixel = 8 THEN
               WavePlaySize& = IndexEntry(Loops).LengthOfData
               GET #255, , WaveBuffer(0)
               ExtractWave = 1
            END IF
         ELSEIF RIGHT$(IndexEntry(Loops).ID, 2) = "pc" THEN
         END IF
         ElapsedTime# = (TIMER - t#) * 1000
         IF ExtractWave = 0 AND BMPInfoHead.BitsPerPixel = 8 THEN CALL Delay(AVIHeader.MicrosecPerFrame - ElapsedTime#)
         IF INKEY$ <> "" THEN Exiting$ = "Exit": EXIT FOR
      NEXT Loops
   LOOP WHILE Exiting$ = ""
   CLOSE #255
END IF

IF Exiting$ = "Exits" THEN
   OPEN SecondFile$ FOR BINARY AS #1
      OUT &H3C7, 0
      Palette$ = ""
      FOR Colors = 0 TO 255
         Red$ = CHR$(INP(&H3C9))
         Green$ = CHR$(INP(&H3C9))
         Blue$ = CHR$(INP(&H3C9))
         Palette$ = Palette$ + Red$ + Green$ + Blue$
      NEXT Colors
      PUT #1, , Frames$
      PUT #1, , Microsec$
      PUT #1, , Palette$
   CLOSE #1
   ERASE Palette8, WaveBuffer
   CALL ShowAVX(SecondFile$)
END IF

END SUB

SUB ShowAVX (FileName$)

DIM Palette8(0) AS STRING * 1024
Frame$ = SPACE$(4)
Microsec$ = SPACE$(4)
Extract$ = SPACE$(32000)

OPEN FileName$ FOR BINARY AS #255
IF LOF(255) = 0 THEN
   PRINT " FILE IS EMPTY"
   CLOSE #255: KILL FileName$: EXIT SUB
END IF

GET #255, , Frame$
GET #255, , Microsec$
GET #255, , Palette8(0)
Frames = CVL(Frame$)
Micros = CVL(Microsec$)

SCREEN 13
OUT &H3C8, 0
FOR Loops = 0 TO 255
   XLoops = Loops * 3
   Red = ASC(MID$(Palette8(0), XLoops + 1, 1))
   Green = ASC(MID$(Palette8(0), XLoops + 2, 1))
   Blue = ASC(MID$(Palette8(0), XLoops + 3, 1))
   OUT &H3C9, Red
   OUT &H3C9, Green
   OUT &H3C9, Blue
NEXT Loops

DO
   SEEK #255, 1033
   FOR Loops = 1 TO Frames
      GET #255, , Extract$
      CALL MemCopy(VARSEG(Extract$), SADD(Extract$), &HA000, 0, 32000)
      GET #255, , Extract$
      CALL MemCopy(VARSEG(Extract$), SADD(Extract$), &HA7D0, 0, 32000)
      IF INKEY$ <> "" THEN
         KeyPressed$ = " "
         EXIT FOR
      END IF
      WAIT &H3DA, 8
      CALL Delay(Micros)
   NEXT Loops
LOOP WHILE KeyPressed$ = ""
CLOSE #255

END SUB

