DECLARE SUB EvaluateDB (ImageWidth%, ImageHeight%, BitsPerPixel%)
DECLARE SUB PlayWaveAudio (Varseg1%, Varptr1%, Channels%, Freq&, Bits%, Length&)
DECLARE SUB SetColor (ColorNumber%, Red%, Green%, Blue%)
DECLARE SUB BITZ24AVI (ImageWidth%, YHeight%, LineExtract$, BitsPerPixel%, StartX%, StartY%)
DECLARE SUB ShowAVX (FileName$)
DECLARE SUB DIBPlay (ImageWidth%, ImageHeight%, BitsPerPixel%)
DECLARE SUB ShowAVI (FileName$, PaletteFile$)
DECLARE SUB SaveBMP (FileName$)
DECLARE SUB LoadAsm ()
DECLARE SUB GetSpeed ()
DECLARE SUB Delay (MiliSeconds%)
DECLARE SUB NearestWord (LongNo AS LONG)
DECLARE SUB RLECompression (ImageHeight AS LONG)
DECLARE SUB AddToLastFive (Blue%, Green%, Red%, Colorz%)
DECLARE SUB MemCopy (FromSeg%, FromOff%, ToSeg%, ToOff%, Bytes%)

TYPE RIFFHeaderType
   ValidID AS STRING * 4
   SizeOfFile AS LONG
   RIFFFileType AS STRING * 4
END TYPE

TYPE ListChunk
   ListID AS STRING * 4
   BytesInList AS LONG
   ListType AS STRING * 4
END TYPE

TYPE Chunk
   ID AS STRING * 4
   Bytes AS LONG
END TYPE

TYPE AVIHeader
   ValidID AS STRING * 4
   Size AS LONG
   MicrosecPerFrame AS LONG
   MaximumBytesPerSec AS LONG
   Reserved1 AS LONG
   BitFlags AS LONG
   TotalFrames AS LONG
   InitialFrame AS LONG
   NoOfStreams AS LONG
   BufferSize AS LONG
   Widthz AS LONG
   Heightz AS LONG
   Scale AS LONG
   Rate AS LONG
   Start AS LONG
   Length AS LONG
END TYPE

TYPE StreamHeader
   HeaderID AS STRING * 4
   BytesIn AS LONG
   Typez AS STRING * 4
   Handle AS STRING * 4
   BitFlags AS LONG
   Reserved1 AS LONG
   InitialFrames AS LONG
   Scale AS LONG
   Rate AS LONG
   Start AS LONG
   Length AS LONG
   BufferSize AS LONG
   Quality AS LONG
   SampleSize AS LONG
END TYPE

TYPE StreamFormat
   ID AS STRING * 4
   BytesIn AS LONG
END TYPE

TYPE BMPHeader
   ValidID AS STRING * 2          '/* Must be 'BM'
   SizeOfFile AS LONG             '/* Size of entire file in bytes
   Reserved AS LONG               '/* Four empty bytes
   OffsetOfBitMap AS LONG         '/* The location in the file where the
                                  '   image data is located
END TYPE

TYPE BMPInfoHeader
   LengthOfHeader AS LONG
   ImageWidth AS LONG
   ImageHeight AS LONG
   Planes AS INTEGER
   BitsPerPixel AS INTEGER
   CompressMethod AS LONG
   ImageSizeInBytes AS LONG
   HorizontalRatio AS LONG
   VerticalRatio AS LONG
   ColorsUsed AS LONG
   ImportantColors AS LONG
END TYPE

TYPE WavHeader
   FormatTag AS INTEGER
   Channels AS INTEGER
   SampleRate AS LONG
   BytesPerSecond AS LONG
   BlockAlignment AS INTEGER
   BitsPerSample AS INTEGER
END TYPE

TYPE ImageData
   ChunkID AS STRING * 4
   NumberOfBytes AS LONG
END TYPE

TYPE Idx1Entries
   ID AS STRING * 4
   Flags AS LONG
   OffsetOfData AS LONG
   LengthOfData AS LONG
END TYPE

